diff --git a/sesman/session.c b/sesman/session.c
index 54e02ad..1eab77d 100644
--- a/sesman/session.c
+++ b/sesman/session.c
@@ -472,6 +1067,7 @@ struct session_chain
   struct session_chain* next;
   struct session_item* item;
 };
+
 */
 
 /******************************************************************************/
@@ -513,6 +1109,12 @@ session_kill(int pid)
       /* deleting the session */
       log_message(&(g_cfg->log), LOG_LEVEL_INFO, "session %d - user %s - terminated",
                   tmp->item->pid, tmp->item->name);
+      if (tmp->item->ck_cookie)
+      {
+	  session_ck_close_session (dbus_bus_get(DBUS_BUS_SYSTEM, 0),
+				    tmp->item->ck_cookie);
+	g_free(tmp->item->ck_cookie);
+      }
       g_free(tmp->item);
       if (prev == 0)
       {
diff --git a/sesman/session.h b/sesman/session.h
index e6c6563..8b9638f 100644
--- a/sesman/session.h
+++ b/sesman/session.h
@@ -33,6 +33,7 @@
 
 #define SESMAN_SESSION_TYPE_XRDP  1
 #define SESMAN_SESSION_TYPE_XVNC  2
+#define SESMAN_SESSION_TYPE_XDMX  3
 
 #define SESMAN_SESSION_STATUS_ACTIVE        1
 #define SESMAN_SESSION_STATUS_IDLE          2
@@ -64,6 +65,7 @@ struct session_item
   int width;
   int height;
   int bpp;
+  int layout;
   long data;
 
   /* status info */
@@ -74,6 +76,9 @@ struct session_item
   struct session_date connect_time;
   struct session_date disconnect_time;
   struct session_date idle_time;
+
+  /* console kit */
+  char *ck_cookie;
 };
 
 struct session_chain
@@ -101,8 +106,9 @@ session_get_bydata(char* name, int width, int height, int bpp);
  *
  */
 int DEFAULT_CC
-session_start(int width, int height, int bpp, char* username, char* password,
-              long data, unsigned char type);
+session_start(int width, int height, int bpp, int layout,
+	      char* username, char* password,
+              char* wm, long data, unsigned char type);
 
 /**
  *
diff --git a/sesman/startwm.sh b/sesman/startwm.sh
index 3445c49..077304e 100755
--- a/sesman/startwm.sh
+++ b/sesman/startwm.sh
@@ -1,48 +1,14 @@
-#!/bin/sh
+#!/bin/bash
+#
+# startwm.sh for SuSE Linux
+#
 
-# edit this file to run whatever window manager you want
-# defaults to running kde
+. /etc/sysconfig/windowmanager
 
-# for kde
-if [ -d /opt/kde3/bin ]; then
-  export PATH=/opt/kde3/bin:$PATH
-fi
-if [ -d /opt/kde/bin ]; then
-  export PATH=/opt/kde/bin:$PATH
-fi
-which startkde
-if [ $? -eq 0 ]; then
-  startkde
-  exit 0
-fi
-which kde
-if [ $? -eq 0 ]; then
-  kde
-  exit 0
-fi
+test -z "$DEFAULT_WM" && DEFAULT_WM=twm
+WINDOWMANAGER="`type -p ${DEFAULT_WM##*/}`"
+unset DEFAULT_WM
 
-# gnome
-which gnome-session
-if [ $? -eq 0 ]; then
-  gnome-session
-  exit 0
-fi
+exec /etc/X11/xdm/Xsession $WINDOWMANAGER
 
-# blackbox
-#if [ "'which blackbox'" != "" ]; then
-#  blackbox
-#  exit 0
-#fi
-
-# fvwm95
-#if [ "'which fvwm95'" != "" ]; then
-#  fvwm95
-#  exit 0
-#fi
-
-# fall back on xterm
-which xterm
-if [ $? -eq 0 ]; then
-  xterm
-  exit 0
-fi
+exit 1
diff --git a/sesman/tools/sesrun.c b/sesman/tools/sesrun.c
index ef280c4..4af08ff 100644
--- a/sesman/tools/sesrun.c
+++ b/sesman/tools/sesrun.c
@@ -44,11 +44,13 @@ main(int argc, char** argv)
   int width;
   int height;
   int bpp;
+  int keylayout;
   int display;
   struct stream* in_s;
   struct stream* out_s;
   char* username;
   char* password;
+  char* exec;
   long data;
 
   if (0 != config_read(&g_cfg))
@@ -60,17 +62,19 @@ main(int argc, char** argv)
   g_pid = g_getpid();
   if (argc == 1)
   {
-    g_printf("xrdp session starter v0.1\n");
+    g_printf("xrdp session starter v0.2\n");
     g_printf("\nusage:\n");
-    g_printf("sesrun <server> <username> <password> <width> <height> <bpp>\n");
+    g_printf("sesrun <server> <username> <password> <exec> <width> <height> <bpp> <keylayout>\n");
   }
-  else if (argc == 7)
+  else if (argc == 9)
   {
     username = argv[2];
     password = argv[3];
-    width = g_atoi(argv[4]);
-    height = g_atoi(argv[5]);
-    bpp = g_atoi(argv[6]);
+    exec = argv[4];
+    width = g_atoi(argv[5]);
+    height = g_atoi(argv[6]);
+    bpp = g_atoi(argv[7]);
+    keylayout = g_atoi(argv[8]);
     make_stream(in_s);
     init_stream(in_s, 8192);
     make_stream(out_s);
@@ -79,16 +83,20 @@ main(int argc, char** argv)
     if (g_tcp_connect(sck, argv[1], "3350") == 0)
     {
       s_push_layer(out_s, channel_hdr, 8);
-      out_uint16_be(out_s, 0); /* code */
+      out_uint16_be(out_s, 20); /* code */
       i = g_strlen(username);
       out_uint16_be(out_s, i);
       out_uint8a(out_s, username, i);
       i = g_strlen(password);
       out_uint16_be(out_s, i);
       out_uint8a(out_s, password, i);
+      i = g_strlen(exec);
+      out_uint16_be(out_s, i);
+      out_uint8a(out_s, exec, i);
       out_uint16_be(out_s, width);
       out_uint16_be(out_s, height);
       out_uint16_be(out_s, bpp);
+      out_uint16_be(out_s, keylayout);
       s_mark_end(out_s);
       s_pop_layer(out_s, channel_hdr);
       out_uint32_be(out_s, 0); /* version */
diff --git a/sesman/tools/sestest.c b/sesman/tools/sestest.c
index 03cd1a1..a95130e 100644
--- a/sesman/tools/sestest.c
+++ b/sesman/tools/sestest.c
@@ -161,8 +161,13 @@ int inputSession(struct SCP_SESSION* s)
   g_printf("session type:\n");
   g_printf("0: Xvnc\n", SCP_SESSION_TYPE_XVNC);
   g_printf("1: x11rdp\n", SCP_SESSION_TYPE_XRDP);
+  g_printf("2: Xdmx\n", SCP_SESSION_TYPE_XDMX);
   integer=menuSelect(1);
-  if (integer==1)
+  if (integer==2)
+  {
+    s->type=SCP_SESSION_TYPE_XDMX;
+  }
+  else if (integer==1)
   {
     s->type=SCP_SESSION_TYPE_XRDP;
   }
diff --git a/vnc/vnc.c b/vnc/vnc.c
index 5f9c9ba..0a34884 100644
--- a/vnc/vnc.c
+++ b/vnc/vnc.c
@@ -874,6 +874,8 @@ lib_framebuffer_update(struct vnc* v)
       in_uint16_be(s, cx);
       in_uint16_be(s, cy);
       in_uint32_be(s, encoding);
+      if (cx > 8192 || cy > 8192)
+        return 1;
       if (encoding == 0) /* raw */
       {
         need_size = cx * cy * Bpp;
@@ -977,7 +979,8 @@ lib_clip_data(struct vnc* v)
   int size;
   int error;
 
-  g_free(v->clip_data);
+  if (v->clip_data)
+    g_free(v->clip_data);
   v->clip_data = 0;
   v->clip_data_size = 0;
   make_stream(s);
@@ -987,9 +990,14 @@ lib_clip_data(struct vnc* v)
   {
     in_uint8s(s, 3);
     in_uint32_be(s, size);
-    v->clip_data = (char*)g_malloc(size, 0);
-    v->clip_data_size = size;
-    error = lib_recv(v, v->clip_data, size);
+    if (size <= 0 || size > 65536)
+	error = 1;
+    if (error == 0)
+    {
+      v->clip_data = (char*)g_malloc(size, 0);
+      v->clip_data_size = size;
+      error = lib_recv(v, v->clip_data, size);
+    }
   }
   if (error == 0)
   {
@@ -1037,7 +1045,7 @@ lib_palette_update(struct vnc* v)
     in_uint8s(s, 1);
     in_uint16_be(s, first_color);
     in_uint16_be(s, num_colors);
-    init_stream(s, 8192);
+    init_stream(s, num_colors * 6);
     error = lib_recv(v, s->data, num_colors * 6);
   }
   if (error == 0)
diff --git a/xrdp/Makefile.am b/xrdp/Makefile.am
index 32dd412..b71f2c0 100644
--- a/xrdp/Makefile.am
+++ b/xrdp/Makefile.am
@@ -33,7 +33,11 @@ xrdpsysconf_DATA = \
 pkgdata_DATA = \
   ad256.bmp \
   xrdp256.bmp \
+  tile256.bmp \
+  opensuse256.bmp \
+  rdc256.bmp \
   sans-10.fv1 \
+  tahoma-10.fv1 \
   cursor0.cur \
   cursor1.cur
 
diff --git a/xrdp/funcs.c b/xrdp/funcs.c
index e2ebdb6..e946660 100644
--- a/xrdp/funcs.c
+++ b/xrdp/funcs.c
@@ -217,7 +217,8 @@ set_string(char** in_str, const char* in)
   {
     return 0;
   }
-  g_free(*in_str);
+  if (*in_str)
+    g_free(*in_str);
   *in_str = g_strdup(in);
   return 0;
 }
diff --git a/xrdp/xrdp.c b/xrdp/xrdp.c
index 344a80b..b876344 100644
--- a/xrdp/xrdp.c
+++ b/xrdp/xrdp.c
@@ -22,6 +22,10 @@
 
 #if defined(_WIN32)
 #include <windows.h>
+#else
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <fcntl.h>
 #endif
 #include "xrdp.h"
 
@@ -139,6 +143,21 @@ pipe_sig(int sig_num)
 }
 
 /*****************************************************************************/
+void DEFAULT_CC
+child_sig(int sig_num)
+{
+  int pid;
+
+  g_writeln("got SIGCHLD(%d)", sig_num);
+
+  pid = g_waitchild();
+  if (pid > 0)
+  {
+    g_writeln("child %d exited", pid);
+  }
+}
+
+/*****************************************************************************/
 void APP_CC
 g_loop(void)
 {
@@ -501,19 +520,12 @@ main(int argc, char** argv)
   if (!no_daemon)
   {
     /* make sure we can write to pid file */
-    fd = g_file_open(XRDP_PID_FILE); /* xrdp.pid */
+    fd = open (XRDP_PID_FILE, O_RDWR | O_CREAT | O_EXCL, S_IRUSR | S_IWUSR);
     if (fd == -1)
     {
       g_writeln("running in daemon mode with no access to pid files, quitting");
       g_exit(0);
     }
-    if (g_file_write(fd, "0", 1) == -1)
-    {
-      g_writeln("running in daemon mode with no access to pid files, quitting");
-      g_exit(0);
-    }
-    g_file_close(fd);
-    g_file_delete(XRDP_PID_FILE);
   }
   if (!no_daemon)
   {
@@ -522,6 +534,8 @@ main(int argc, char** argv)
     if (pid == -1)
     {
       g_writeln("problem forking");
+      close (fd);
+      g_file_delete(XRDP_PID_FILE);
       g_exit(1);
     }
     if (0 != pid)
@@ -543,20 +557,10 @@ main(int argc, char** argv)
   {
     /* write the pid to file */
     pid = g_getpid();
-    fd = g_file_open(XRDP_PID_FILE); /* xrdp.pid */
-    if (fd == -1)
-    {
-      g_writeln("trying to write process id to xrdp.pid");
-      g_writeln("problem opening xrdp.pid");
-      g_writeln("maybe no rights");
-    }
-    else
-    {
-      g_set_file_rights(XRDP_PID_FILE, 1, 1); /* xrdp.pid */
-      g_sprintf(text, "%d", pid);
-      g_file_write(fd, text, g_strlen(text));
-      g_file_close(fd);
-    }
+    g_set_file_rights(XRDP_PID_FILE, 1, 1); /* xrdp.pid */
+    g_sprintf(text, "%d", pid);
+    g_file_write(fd, text, g_strlen(text));
+    close (fd);
   }
 #endif
   g_threadid = tc_get_threadid();
@@ -565,6 +569,7 @@ main(int argc, char** argv)
   g_signal(9, xrdp_shutdown); /* SIGKILL */
   g_signal(13, pipe_sig); /* sig pipe */
   g_signal(15, xrdp_shutdown); /* SIGTERM */
+  g_signal_child_stop(child_sig); /* SIGCHLD */
   g_sync_mutex = tc_mutex_create();
   g_sync1_mutex = tc_mutex_create();
   g_term_event = g_create_wait_obj("xrdp_main_term");
diff --git a/xrdp/xrdp.h b/xrdp/xrdp.h
index 94e6ed5..8d8a442 100644
--- a/xrdp/xrdp.h
+++ b/xrdp/xrdp.h
@@ -92,6 +92,10 @@ xrdp_wm_load_static_colors(struct xrdp_wm* self);
 int APP_CC
 xrdp_wm_load_static_pointers(struct xrdp_wm* self);
 int APP_CC
+xrdp_wm_load_sections(struct xrdp_wm* self,
+		      struct list* string_list,
+		      struct list* data_list);
+int APP_CC
 xrdp_wm_init(struct xrdp_wm* self);
 int APP_CC
 xrdp_wm_send_bitmap(struct xrdp_wm* self, struct xrdp_bitmap* bitmap,
@@ -395,3 +399,5 @@ server_get_channel_id(struct xrdp_mod* mod, char* name);
 int DEFAULT_CC
 server_send_to_channel(struct xrdp_mod* mod, int channel_id,
                        char* data, int data_len);
+int DEFAULT_CC
+server_set_login_mode(struct xrdp_mod* mod, int login_mode);
diff --git a/xrdp/xrdp.ini b/xrdp/xrdp.ini
index 5b635dd..a91fad0 100644
--- a/xrdp/xrdp.ini
+++ b/xrdp/xrdp.ini
@@ -6,47 +6,18 @@ port=3389
 crypt_level=low
 channel_code=1
 
-[xrdp1]
-name=sesman-Xvnc
-lib=libvnc.so
+[xsessions]
+path=/usr/share/xsessions
+lib=libdmx.so
 username=ask
 password=ask
 ip=127.0.0.1
 port=-1
 
-[xrdp2]
-name=console
+[failsafe]
+name=Failsafe Terminal
+exec=xterm
 lib=libvnc.so
-ip=127.0.0.1
-port=5900
-username=na
-password=ask
-
-[xrdp3]
-name=vnc-any
-lib=libvnc.so
-ip=ask
-port=ask5900
-username=na
-password=ask
-
-[xrdp4]
-name=sesman-any
-lib=libvnc.so
-ip=ask
-port=-1
-username=ask
-password=ask
-
-[xrdp5]
-name=rdp-any
-lib=librdp.so
-ip=ask
-port=ask3389
-
-[xrdp6]
-name=sesman-X11rdp
-lib=libxup.so
 username=ask
 password=ask
 ip=127.0.0.1
